<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">

<div id="advEditor">
	<div>
		<div class="adve-controls" ondragstart="return false" onselectstart="return false">
			<button title="Desfazer" class="adve-undo"><i class="material-icons">undo</i></button>
			<button title="Negrito" class="adve-bold"><i class="material-icons">format_bold</i></button>
			<button title="Itálico" class="adve-italic"><i class="material-icons">format_italic</i></button>
			<button title="Sublinhado" class="adve-underline"><i class="material-icons">format_underline</i></button>
			<button title="Sublinhado no meio do texto" class="adve-strike"><i class="material-icons">strikethrough_s</i></button>
			<button title="Quebrar linha" class="adve-br"><i class="material-icons">subdirectory_arrow_left</i></button>
			<button title="Criar link" class="adve-link">
				<i eid="link_button_click" class="material-icons">insert_link</i>
				<div style="position: absolute;">
					<div eid="link_options">
						<div>
							<input eid="link" type="" name="">
							<span eid="insert_link_button" class="adve-btn-opt">Inserir</span>
						</div>
						<div style="text-align: left; margin-top: 7px; margin-bottom: 5px">
							<label><input eid="link_newtab" type="checkbox" name=""> Abrir em nova guia</label>
						</div>
					</div>
				</div>
			</button>
			<button title="Remover link" class="adve-unlink"><i class="material-icons">crop_7_5</i></button>
			<button title="Cor do texto" class="adve-color"><i class="material-icons">format_color_text</i>
				<input type="color" name="" id='adve_color' style='display: none'>
			</button>
			<button title="Cor do fundo do texto" class="adve-color-background"><i class="material-icons">color_lens</i>
				<input type="color" name="" id='adve_color_background' style='display: none'>
			</button>
			<button title="Mudar tamanho da fonte" class="adve-fontsize">
				<i eid="fontsize_click" class="material-icons">text_fields</i>
				<div style="position: absolute;">
					<div eid="fontsize_options" style="left: -36px;">
						<div>
							<label>Escolha o tamanho da fonte</label><br>
							<select eid="fontsize_input" class="eid-imgstlsht" style="outline:none">
								<option value="1">Muito Pequena</option>
								<option value="2">Pequena</option>
								<option value="3">Média Pequena</option>
								<option value="4">Média</option>
								<option value="5">Média Grande</option>
								<option value="6">Grande</option>
								<option value="7">Grande Muito Grande</option>
							</select>
						</div>
					</div>
				</div>
			</button>
			<button title="Transformar seleção em lista enumerada" class="adve-order-list"><i class="material-icons">format_list_numbered</i></button>
			<button title="Transformar seleção em lista de pontos" class="adve-point-list"><i class="material-icons">format_list_bulleted</i></button>
			<button title="Insere separador em forma de linha" class="adve-line"><i class="material-icons">remove</i></button>
			<button title="Inserir imagem" class="adve-image">
				<i eid="image_button_click" class="material-icons">image</i>
				<div style="position: absolute;">
					<div eid="image_options">
						<div>
							<label>Link da imagem</label><br>
							<input eid="image" class="eid-imgstlsht" type="" name="">
							<span eid="insert_image_uri_button" class="adve-btn-opt">Inserir</span>
						</div>
						<br>
						<div>
							<label style="display:block; margin-bottom:10px">Ou carregue da biblioteca</label>
							<span eid="insert_image_button" class="adve-btn-w100">Carregar</span>
						</div>
					</div>
				</div>
			</button>
			<button title="Inserir video do YouTube" class="adve-video-youtube">
				<i eid="video_youtube_button_click" class="material-icons">movie</i>
				<div style="position: absolute;">
					<div eid="video_youtube_options" style="left: -36px;">
						<div>
							<label>Link do vídeo do YouTube</label><br>
							<input eid="video_youtube_link" class="eid-imgstlsht" type="" name="">
							<span eid="insert_video_youtube_uri_button" class="adve-btn-opt">Inserir</span>
						</div>
					</div>
				</div>
			</button>
			<button title="Alinhar à esquerda" class="adve-align-left"><i class="material-icons">format_align_left</i></button>
			<button title="Centralizar" class="adve-align-center"><i class="material-icons">format_align_center</i></button>
			<button title="Alinhar à direita" class="adve-align-right"><i class="material-icons">format_align_right</i></button>
			<?php /*if ($Adve_exists_Comments): ?>
			<button title="Inserir comentários" class="adve-plugin-comments"><i class="material-icons">insert_comment</i></button>
			<?php endif;*/ ?>
			<?php if ($Adve_Plugins): 
				$plugins = json_decode(utf8_encode(urldecode($Adve_Plugins)));
				foreach ($plugins as $plugin): ?>
					<button title="<?php echo $plugin->title; ?>" class="adve-plugin-<?php echo $plugin->class_name; ?>"><i class="material-icons"><?php echo $plugin->icon; ?></i></button>
				<?php endforeach; ?>
			<?php endif; ?>
		</div>
		<iframe></iframe>
	</div>

<!-- 	<div>
		<div eid="plus_button">
			<div eid="plus">
				<i eid="plus_button_click" class="material-icons">add_circle</i>
				<div style="position: absolute;">
					<div eid="plus_options">
						<button eid="text"><i class="material-icons">text_fields</i></button>
						<button eid="image"><i class="material-icons">image</i></button>
					</div>
				</div>
			</div>
		</div>
	</div>
	 -->



</div>
 