String.prototype.replaceAll = function(from, to){
	return this.split(from).join(to);
}

var plusBtns = document.querySelectorAll('[eid="plus_button"]');
if (plusBtns.length) plusBtns.forEach(function(btn) {
	var showOptions = function() {
		var plusOptions = this.parentNode.querySelector('[eid="plus_options"]');
		plusOptions.style.display = 'block';


		var optionButtons = plusOptions.querySelectorAll('button');
		console.log(optionButtons);
		if (optionButtons.length) optionButtons.forEach(function(optBtn) {
			optBtn.onclick = function() {
				plusOptions.style.display = 'none';
			}
		});


		setTimeout(function() {
			plusOptions.style.display = 'none';
		}, 15000);
	}

	var i = btn.querySelector('[eid="plus_button_click"]');

	i.onclick = showOptions;
	i.onmouseenter = showOptions;
}); 

function controlResizeImage(doc) {
	var imgs = doc.querySelectorAll("img");
	if (imgs.length) imgs.forEach(function(img) {
		img.onclick = function() {
		 	doc.querySelectorAll("img").forEach(function(img_) {	
		 		img_.style.border = "none";
		 	});
			// img.style.border = "4px solid #00b9eb";

			var moving = img.getAttribute("emoving");
			if (moving) {
				img.setAttribute("emoving", "");
		 		img.style.border = "none";
				img.style.cursor = "pointer";
			}
			else {
				img.style.cursor = "nesw-resize";
				img.setAttribute("emoving", "true");
				img.style.padding = "6px";
			}
		}
		img.onmousemove = function(e) {
			var moving = img.getAttribute("emoving");
			if (moving) {
				console.log(e.clientX - img.offsetLeft);
				var x = e.clientX - img.offsetLeft;
				// clientx - left
				// img.style.width = (e.clientX + 15) + "px";
				img.style.width = (x + 20) + "px";
			}
		}
	});
}

function controlResizeiFrame(doc) {
	var imgs = doc.querySelectorAll('.adve-video-iframe-wrapper');
	if (imgs.length) imgs.forEach(function(img) {

		img.onclick = function() {
		 	doc.querySelectorAll('.adve-video-iframe-wrapper').forEach(function(img_) {	
		 		img_.style.border = "none";
		 	});
			// img.style.border = "4px solid #00b9eb";

			var movebox = img.querySelector('.adve-video-iframe-move');

			var moving = img.getAttribute("emoving");
			if (moving == "true") {
				img.setAttribute("emoving", "false");
		 		// img.style.border = "none";
				// img.style.cursor = "pointer";
				movebox.removeAttribute("adve-video-iframe-moving", "");
			}
			else {
				// img.style.cursor = "se-resize";
				img.setAttribute("emoving", "true");
				// img.style.padding = "6px";
				// movebox.style.width = 'calc(100% - 12px)';
				// movebox.style.height = 'calc(100% - 12px)';
				movebox.setAttribute("adve-video-iframe-moving", "");
			}
		}
		img.onmousemove = function(e) {
			var moving = img.getAttribute("emoving");
			if (moving == "true") {
				var x = e.clientX - img.offsetLeft;
				var y = e.clientY - img.offsetTop;
				// clientx - left
				// img.style.width = (e.clientX + 15) + "px";
				img.querySelector('iframe').style.width = (x + 20) + "px";
				img.querySelector('iframe').style.height = (y + 20) + "px";
			}
		}
	});
}

var blocks = document.querySelectorAll("#advEditor > div");
if (blocks) if (blocks.length) {
	blocks.forEach(function(block) {
		var richTextEditor = block.querySelector("iframe");
		if (richTextEditor) {
			// dentro do editor

			var box = richTextEditor.parentNode;

			var doc = richTextEditor.contentWindow.document;
			doc.designMode = "on";

			doc.body.innerHTML = "Digite aqui...";

			richTextEditor.style.transition = '.01s ease-in';


			richTextEditor.onmouseenter = function() {
				var plusOptions = document.querySelectorAll('[eid="plus_options"]');
				if (plusOptions.length) plusOptions.forEach(function(opt) {
					opt.style.display = 'none';
				});

				var list = controls.querySelectorAll('[eid$="_options"]');
				if (list.length) list.forEach(function(item) {
					item.style.display = 'none';
				});

				var insertLinks = document.querySelectorAll('[eid="link_options"]');
				if (insertLinks) insertLinks.forEach(function(il) {
					il.style.display = 'none';
					var input_link = il.querySelector('[eid="link"]');
					input_link.value = "";
				});

				var insertImages = document.querySelectorAll('[eid="image_options"]');
				if (insertImages) insertImages.forEach(function(il) {
					il.style.display = 'none';
					var image_link = il.querySelector('[eid="image"]');
					image_link.value = "";
				});

				var insertVideosYoutube = document.querySelectorAll('[eid="video_youtube_options"]');
				if (insertVideosYoutube) insertVideosYoutube.forEach(function(il) {
					il.style.display = 'none';
					var video_youtube_link = il.querySelector('[eid="video_youtube_link"]');
					video_youtube_link.value = "";
				});
			}

			var html = doc.querySelector("html");
			var head = doc.querySelector("head");
			var body = doc.querySelector("body");


			var adjustHeight = function() {
				richTextEditor.style.height = body.offsetHeight + 'px';
			}

			setInterval(adjustHeight, 30);
			//doc.onkeyup = adjustHeight;

			if (html && head && body) {
				html.style.overflow = 'hidden';
				head.innerHTML += '<link href="https://fonts.googleapis.com/css2?family=Open+Sans:ital,wght@0,300;0,400;0,600;0,700;1,300;1,400;1,600&display=swap" rel="stylesheet">';
				body.style.font = "20px 'open sans', arial";

				head.innerHTML += "<style>"
				+"body { font: 20px 'open sans', arial; }"
				+"img { cursor: pointer; max-width: calc(100% - 40px); border: 4px solid transparent; } "
				+".adve-video-iframe-container { cursor: default; height: 315px; display: inline-block; margin-bottom: 30px; min-height: 150px } "
				+".adve-video-iframe-wrapper { position: absolute; display: inline-block; } "
				+".adve-video-iframe-move { width: calc(100%); height: calc(100%); position: absolute; background: black; opacity: .5; } "
				+"[adve-video-iframe-moving] { width: calc(100% - 12px)!important; height: calc(100% - 12px)!important; } "
				+"div[emoving='false'] { cursor: default; } "
				+"div[emoving='true'] { cursor: se-resize!important; padding: 6px; border: 4px solid #00b9eb; } "
				+"div[adve-block-shortcode] { padding: 20px 10px; border: 4px dashed #ccc; } "
				+"</style>";
			}

			var controls = richTextEditor.parentNode.querySelector(".adve-controls");
			
			doc.onclick = function() {
				controlResizeImage(doc);
				controlResizeiFrame(doc);

				if (doc.body.innerHTML == "Digite aqui...") doc.body.innerHTML = "";

				var listControls = document.querySelectorAll(".adve-controls");
				listControls.forEach(function(ctrl) {
					ctrl.style.opacity = 0;
				});
				controls.style.opacity = 1;
			}
			
			if (controls) {
				var B = controls.querySelector('.adve-bold');
				var I = controls.querySelector('.adve-italic');
				var U = controls.querySelector('.adve-underline');
				var br = controls.querySelector('.adve-br');
				var link = controls.querySelector('.adve-link');
				var image = controls.querySelector('.adve-image');
				var video_youtube = controls.querySelector('.adve-video-youtube');
				var undo = controls.querySelector('.adve-undo');
				var strike = controls.querySelector('.adve-strike');
				var unlink = controls.querySelector('.adve-unlink');
				var orderList = controls.querySelector('.adve-order-list');
				var pointList = controls.querySelector('.adve-point-list');
				var line = controls.querySelector('.adve-line');
				var alignLeft = controls.querySelector('.adve-align-left');
				var alignCenter = controls.querySelector('.adve-align-center');
				var alignRight = controls.querySelector('.adve-align-right');
				var fontSize = controls.querySelector('.adve-fontsize');
				var color = controls.querySelector('.adve-color');
				var colorBg = controls.querySelector('.adve-color-background');



				var link_button_click = link.querySelector('[eid="link_button_click"]');
				var image_button_click = image.querySelector('[eid="image_button_click"]');
				var video_youtube_button_click = video_youtube.querySelector('[eid="video_youtube_button_click"]');
				var fontsize_click = fontSize.querySelector('[eid="fontsize_click"]');

				var link_options = link.querySelector('[eid="link_options"]');
				var image_options = image.querySelector('[eid="image_options"]');
				var video_youtube_options = video_youtube.querySelector('[eid="video_youtube_options"]');
				var fontsize_options = fontSize.querySelector('[eid="fontsize_options"]');

				colorBg.onclick = function() {
					adve_color_background.click();
				}

				adve_color_background.onchange = function() {
					doc.execCommand("backColor", false, this.value);
				}

				color.onclick = function() {
					adve_color.click();
				}

				adve_color.onchange = function() {
					doc.execCommand("foreColor", false, this.value);
				}

				br.onclick = function() {
					doc.execCommand("insertLineBreak", false, null);
				}

				B.onclick = function() {
					doc.execCommand("bold", false, null);
				}

				I.onclick = function() {
					doc.execCommand("italic", false, null);
				}

				U.onclick = function() {
					doc.execCommand("underline", false, null);
				}

				if (undo) undo.onclick = function() {
					doc.execCommand("undo", false, null);
				}

				if (strike) strike.onclick = function() {
					doc.execCommand("strikethrough", false, null);
				}

				if (unlink) unlink.onclick = function() {
					doc.execCommand("unlink", false, null);
				}

				if (orderList) orderList.onclick = function() {
					doc.execCommand("insertOrderedList", false, null);
				}

				if (pointList) pointList.onclick = function() {
					doc.execCommand("insertUnorderedList", false, null);
				}

				if (line) line.onclick = function() {
					doc.execCommand("insertHorizontalRule", false, null);
				}

				if (alignLeft) alignLeft.onclick = function() {
					doc.execCommand("justifyLeft", false, null);
				}

				if (alignCenter) alignCenter.onclick = function() {
					doc.execCommand("justifyCenter", false, null);
				}

				if (alignRight) alignRight.onclick = function() {
					doc.execCommand("justifyRight", false, null);
				}


				// if (pluginComments) pluginComments.onclick = function() {
				// 	var selection = doc.getSelection();
				// 	doc.execCommand('insertHTML', false, "<br>%comments%<br>");
				// }

				<?php if (isset($Adve_Plugins)): 
					$plugins = json_decode(utf8_encode(urldecode($Adve_Plugins)));
					if (sizeof($plugins)) foreach ($plugins as $plugin): ?>

						<?php if (isset($plugin->style_iframe)): ?>
						head.innerHTML += "<style><?php echo $plugin->style_iframe; ?></style>";
						<?php endif; ?>

						var <?php echo $plugin->variable; ?> = controls.querySelector('.adve-plugin-<?php echo $plugin->class_name; ?>');

						if (<?php echo $plugin->variable; ?>) <?php echo $plugin->variable; ?>.onclick = function() {
							<?php echo $plugin->action; ?>						
						}
					<?php endforeach; ?>
				<?php endif; ?>



				// fontsize

				if (fontsize_click) fontsize_click.onclick = function() {
					//image_options.style.display = 'none';

					var list = controls.querySelectorAll('[eid$="_options"]');
					if (list.length) list.forEach(function(item) {
						item.style.display = 'none';
					});

					fontsize_options.style.display = 'block';
				}

				// apply

				if (fontsize_options) {
					var insert_fontsize_button = fontsize_options.querySelector('[eid="insert_fontsize_button"]');
					var fontsize_input = fontsize_options.querySelector('[eid="fontsize_input"]');

					fontsize_input.onchange = function() {
						// 	doc.execCommand('insertHTML', false, '<a href="' + link_input.value + '" target="_blank">' + textSelected + '</a>');
						doc.execCommand("fontSize", false, fontsize_input.value);

						fontsize_options.style.display = 'none';
						fontsize_input.value = "";
					}
				}


				// link

				if (link_button_click) link_button_click.onclick = function() {
					//image_options.style.display = 'none';

					var list = controls.querySelectorAll('[eid$="_options"]');
					if (list.length) list.forEach(function(item) {
						item.style.display = 'none';
					});

					link_options.style.display = 'block';
					link_input.focus();
				}

				if (link_options) {
					var insert_link_button = link_options.querySelector('[eid="insert_link_button"]');
					var link_input = link_options.querySelector('[eid="link"]');
					var link_newtab = link_options.querySelector('[eid="link_newtab"]');

					insert_link_button.onclick = function() {
						// 	doc.execCommand('insertHTML', false, '<a href="' + link_input.value + '" target="_blank">' + textSelected + '</a>');
						doc.execCommand("CreateLink", false, link_input.value);

						var selection = doc.getSelection();

						console.log(selection);

						if (link_newtab.checked) {
							selection.target = '_blank';
							selection.focusNode.target = '_blank';
							selection.focusNode.parentElement.target = '_blank';
						}

						link_newtab.checked = false;
						link_options.style.display = 'none';
						link_input.value = "";
					}
				}

				// video youtube
				if (video_youtube_button_click) video_youtube_button_click.onclick = function() {
					var list = controls.querySelectorAll('[eid$="_options"]');
					if (list.length) list.forEach(function(item) {
						item.style.display = 'none';
					});

					video_youtube_options.style.display = 'block';
				}

				if (video_youtube_options) {
					var insert_video_youtube_uri_button = video_youtube_options.querySelector('[eid="insert_video_youtube_uri_button"]');
					var video_youtube_link_input = video_youtube_options.querySelector('[eid="video_youtube_link"]');

					insert_video_youtube_uri_button.onclick = function() {

						var ytID = video_youtube_link_input.value.split("?v=");
						if (ytID.length>1) ytID = ytID[1];
						else {
							ytID = video_youtube_link_input.value.split("/");
							console.log(ytID);
							console.error(ytID.length - 1);
							ytID = ytID[ytID.length - 1];
						}

						var selection = doc.getSelection();
						doc.execCommand('insertHTML', false, 
						'<br><div><div class="adve-video-iframe-container"><div class="adve-video-iframe-wrapper"><div class="adve-video-iframe-move"></div><iframe width="560" height="315" src="https://www.youtube.com/embed/' + ytID +'" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe></div></div></div><br>');
						video_youtube_options.style.display = 'none';
						video_youtube_link_input.value = "";

						controlResizeiFrame(doc);
					}
				}

				// image

				if (image_button_click) image_button_click.onclick = function() {
					var list = controls.querySelectorAll('[eid$="_options"]');
					if (list.length) list.forEach(function(item) {
						item.style.display = 'none';
					});

					image_options.style.display = 'block';
				}

				if (image_options) {
					var insert_image_button = image_options.querySelector('[eid="insert_image_button"]');
					var insert_image_uri_button = image_options.querySelector('[eid="insert_image_uri_button"]');
					var image_input = image_options.querySelector('[eid="image"]');

					insert_image_uri_button.onclick = function() {
						doc.execCommand("InsertImage", false, image_input.value);

						image_options.style.display = 'none';
						image_input.value = "";

						controlResizeImage(doc);
					}

					insert_image_button.onclick = function() {
						image_options.style.display = 'none';
						image_input.value = "";

						// upload
						var $button = jQuery(this);

						var file_frame = wp.media.frames.file_frame = wp.media({
						 title: "Upload da imagem",
						 library: { // remove these to show all
						    type: 'image' // specific mime
						 },
						 button: {
						    text: "Selecionar"
						 },
						 multiple: false  // Set to true to allow multiple files to be selected
						});

						file_frame.on('select', function () {
						 var attachment = file_frame.state().get('selection').first().toJSON();

						 jQuery('.media-modal-close').click();
						 
							 doc.execCommand("InsertImage", false, attachment.url);
							 controlResizeImage(doc);
						});

						file_frame.open();
						// end upload
					  
			

					}
				}
				
			}

		}
	});
}