<?php
/*
Plugin Name:		Adverttorial
Plugin URI: 		http://ezeksoft.com/adverttorial/?utm_source=plugin-page&utm_medium=wordpress&utm_content=plugged&utm_campaign=organic&v=lite&utm_page=plugins
Description:		Crie seu Advertorial rapidamente
Version: 			1.0.1
Author: 			Ezeksoft
Author URI: 		http://ezeksoft.com
*/





/** ********
 * imports
 **/

require(dirname( __FILE__ ) . DIRECTORY_SEPARATOR. 'Ezeksoft.class.php');
$Ezeksoft_Adverttorial = new Ezeksoft_Adverttorial();
global $wpdb;




/** ********
 * defines
 **/

if (!defined('ADVERTTORIAL_TABLENAME')) define("ADVERTTORIAL_TABLENAME", "adverttorial_v1");

//delete_option("Adverttorial_Plugins");
if (!get_option("Adverttorial_Plugins"))
update_option("Adverttorial_Plugins", urlencode( json_encode( 
	array()
) ));




/** ********
 * functions
 **/

// download adve
function ajax_adve_export_adve()
{
	error_reporting(E_ALL);
	ini_set('display_errors', 1);
	global $wpdb;
	$id = (int) $_REQUEST['id'];

	$data = null;
	$uri = "";
	
	if ($id) $data = $wpdb->get_results("SELECT * FROM ".ADVERTTORIAL_TABLENAME." WHERE id = " . $id);
	
	if (!empty($data)) {
		$data = $data[0];
		$uri = $data->uri;
	}
	
	
	$filename = "advertorial_{$uri}_[Ezeksoft_Adverttorial].txt";

	header("Content-type: application/x-msdownload", true, 200);
	header("Content-Disposition: attachment; filename=".$filename);
	header("Pragma: no-cache");
	header("Expires: 0");


	if (!empty($data)) 
	{
		echo json_encode(array($data));
	}
	exit();
	die();
}

add_action("wp_ajax_adve_export_adve", "ajax_adve_export_adve");

// download all adve
function ajax_adve_export_adve_all()
{
	global $wpdb;

	$data = null;
	
	$data = $wpdb->get_results("SELECT * FROM ".ADVERTTORIAL_TABLENAME);
	
	$filename = "advertorial_TODOS_[Ezeksoft_Adverttorial].txt";

	header("Content-type: application/x-msdownload", true, 200);
	header("Content-Disposition: attachment; filename=".$filename);
	header("Pragma: no-cache");
	header("Expires: 0");

	if (sizeof($data)) 
	{
		echo json_encode($data);
	}
	exit();
	die();
}
add_action("wp_ajax_adve_export_adve_all", "ajax_adve_export_adve_all");

// import comments
function ajax_adve_import_adve()
{
	global $wpdb;
	$data = $_POST['string'];

	if (sizeof($data))
	{
		foreach ($data as $item)
		{
			$item = (object) $item;
			$sql = "INSERT INTO ".ADVERTTORIAL_TABLENAME."(id, uri, html, headline, author, date, template, template_main_color, template_sub_color, template_main_text_color) VALUES(NULL, '$item->uri', '$item->html', '$item->headline', '$item->author', '$item->date', '$item->template', '$item->template_main_color', '$item->template_sub_color', '$item->template_main_text_color')";
			$wpdb->query($sql);

		}
	}
	wp_die();

}

add_action("wp_ajax_adve_import_adve", "ajax_adve_import_adve");

function Adverttorial_render_html()
{

	/**
	 * @imports
	 */

	global $Ezeksoft_Adverttorial;
	$Adve_exists_Comments =  is_plugin_active("adverttorial-comments/index.php");
	$Adve_exists_Templates =  is_plugin_active("adverttorial-templates/index.php");
	$Adve_Plugins = get_option("Adverttorial_Plugins");
	$Adve_Templates = get_option("Adverttorial_Templates");

	// uploader
 	wp_enqueue_media(); 

 	// user
	$current_user = wp_get_current_user();
	$author = $current_user->user_firstname;

	// ajax
	$ajaxurl = json_encode(get_bloginfo('wpurl') . "/wp-admin/admin-ajax.php");
	$ajaxurl_jshtml = "<script type='text/javascript'>var ajaxurl = $ajaxurl; if (document.location.protocol == 'https:') { if ( !(/https\:\/\//.test(ajaxurl)) ) ajaxurl = ajaxurl.replace('http://', 'https://'); };</script>";

	// date
	//$date = date("d/m/Y H") . "h" . date("m");


	/**
	 * @data
	 */

	$data = $Ezeksoft_Adverttorial->get_option(ADVERTTORIAL_TABLENAME, null, 1);

	$Adve_Template_Name = get_option("Adverttorial_Template_Name");
	$Adve_Template_Name = $Adve_Template_Name ? $Adve_Template_Name : "G1 News";


	/**
	 * @render
	 */

	echo $ajaxurl_jshtml;

	if ($Adve_exists_Comments || $Adve_exists_Templates) 
	{
		if (get_option("adverttorial"))
			require(dirname( __FILE__ ) . DIRECTORY_SEPARATOR. 'panel.php');
		else {
			require(dirname( __FILE__ ) . DIRECTORY_SEPARATOR. 'license.php');
			require(dirname( __FILE__ ) . DIRECTORY_SEPARATOR. 'wo_lic_panel.php');
		}
	}
	else require(dirname( __FILE__ ) . DIRECTORY_SEPARATOR. 'wo_lic_panel.php');
}

function adverttorial_add_key()
{
	update_option("adverttorial", $_POST['key']);
	wp_die();
}
add_action("wp_ajax_adverttorial_add_key", "adverttorial_add_key");

function adverttorial_del_key()
{
	delete_option("adverttorial");
	wp_die();
}
add_action("wp_ajax_adverttorial_del_key", "adverttorial_del_key");



function Adverttorial_render_html_edit()
{

	/**
	 * @imports
	 */

	global $Ezeksoft_Adverttorial;
	$Adve_exists_Comments =  is_plugin_active("adverttorial-comments/index.php");
	$Adve_exists_Templates =  is_plugin_active("adverttorial-templates/index.php");
	$Adve_Plugins = get_option("Adverttorial_Plugins");
	$Adve_Templates = get_option("Adverttorial_Templates");

	// uploader
 	wp_enqueue_media(); 

 	// user
	$current_user = wp_get_current_user();
	$author = $current_user->user_firstname;

	// ajax
	$ajaxurl = json_encode(get_bloginfo('wpurl') . "/wp-admin/admin-ajax.php");
	$ajaxurl_jshtml = "<script type='text/javascript'>var ajaxurl = $ajaxurl; if (document.location.protocol == 'https:') { if ( !(/https\:\/\//.test(ajaxurl)) ) ajaxurl = ajaxurl.replace('http://', 'https://'); };</script>";


	/**
	 * @data
	 */

	$Adverttorial_Editing_ID = (int) get_option("Adverttorial_Editing_ID");
	$data = null;
	if ($Adverttorial_Editing_ID) $data = $Ezeksoft_Adverttorial->get_option(ADVERTTORIAL_TABLENAME, $Adverttorial_Editing_ID);
	if (!is_null($data)) { if (sizeof($data)) $data = $data[0]; }


	$Adverttorial_Headline = $data->headline;
	$Adverttorial_Sub_Headline = $data->sub_headline;
	$Adverttorial_Sub_TUse = $data->tuse;
	$Adverttorial_Sub_PPriv = $data->ppriv;
	$Adverttorial_HTML = $data->html;
	$Adverttorial_Author = $data->author;
	$Adverttorial_Date = $data->date;
	$Adve_Template = $data->template;
	$Adve_Template_Main_Color = $data->template_main_color;
	$Adve_Template_Sub_Color = $data->template_sub_color;


	/**
	 * @render
	 */

	echo $ajaxurl_jshtml;

	delete_option("Adverttorial_Editing_ID");

	require(dirname( __FILE__ ) . DIRECTORY_SEPARATOR. 'panel_edit.php');

}

function Adverttorial_add_to_menu_fn()
{
	add_menu_page(
		"Adverttorial", // <title>
		"Adverttorial", // label menu
		"manage_options", // chmod
		"adverttorial", // perma
		"Adverttorial_render_html", // render panel
		plugins_url('', __FILE__) . "/icon.png" // icon
	);

	add_submenu_page(
		"",
		'Editar',
		'Editar',
		'manage_options',
		'adverttorial-editar',
		'Adverttorial_render_html_edit'
	);


}

add_action('admin_menu', 'Adverttorial_add_to_menu_fn');




/** ********
 * Ajax functions
 **/

// save
function ajax_adve_save()
{
	global $Ezeksoft_Adverttorial;

	$uri = $_POST['uri'];
	$html = $_POST['html'];
	$headline = $_POST['headline'];
	$author = $_POST['author'];
	$date = $_POST['date'];
	$template = $_POST['template'];
	$template_main_color = $_POST['template_main_color'];
	$template_sub_color = $_POST['template_sub_color'];
	$sub_headline = $_POST['sub_headline'];
	$tuse = $_POST['tuse'];
	$ppriv = $_POST['ppriv'];
	$headertit = $_POST['headertit'];
	$sub_headertit = $_POST['sub_headertit'];
	$scripts = $_POST['scripts'];

	$Ezeksoft_Adverttorial->update_option(ADVERTTORIAL_TABLENAME, array(
		"uri" => $uri,
		"html" => $html,
		"headline" => $headline,
		"author" => $author,
		"date" => $date,
		"template" => $template,
		"template_main_color" => $template_main_color,
		"template_sub_color" => $template_sub_color,
		"sub_headline" => $sub_headline,
		"tuse" => $tuse,
		"ppriv" => $ppriv,
		"headertit" => $headertit,
		"sub_headertit" => $sub_headertit,
		"scripts" => $scripts,
	));

	wp_die();
} 

add_action("wp_ajax_adve_save", "ajax_adve_save");

// edit
function ajax_adve_edit()
{
	global $Ezeksoft_Adverttorial;

	$id = $_POST['id'];
	$uri = $_POST['uri'];
	$html = $_POST['html'];
	$headline = $_POST['headline'];
	$author = $_POST['author'];
	$date = $_POST['date'];
	$template = $_POST['template'];
	$template_main_color = $_POST['template_main_color'];
	$template_sub_color = $_POST['template_sub_color'];
	$sub_headline = $_POST['sub_headline'];
	$tuse = $_POST['tuse'];
	$ppriv = $_POST['ppriv'];
	$headertit = $_POST['headertit'];
	$sub_headertit = $_POST['sub_headertit'];
	$scripts = $_POST['scripts'];

	$Ezeksoft_Adverttorial->update_option(ADVERTTORIAL_TABLENAME, array(
		"uri" => $uri,
		"html" => $html,
		"headline" => $headline,
		"author" => $author,
		"date" => $date,
		"template" => $template,
		"template_main_color" => $template_main_color,
		"template_sub_color" => $template_sub_color,
		"sub_headline" => $sub_headline,
		"tuse" => $tuse,
		"ppriv" => $ppriv,
		"headertit" => $headertit,
		"sub_headertit" => $sub_headertit,
		"scripts" => $scripts,
	), $id);

}

add_action("wp_ajax_adve_edit", "ajax_adve_edit");

function ajax_adve_edit_order() {
	$id = $_POST['id'];

	update_option("Adverttorial_Editing_ID", $id);

	wp_die();
}

add_action("wp_ajax_adve_edit_order", "ajax_adve_edit_order");

// del
function ajax_adve_del()
{
	global $Ezeksoft_Adverttorial;

	$id = $_POST['id'];
	$Ezeksoft_Adverttorial->delete_option(ADVERTTORIAL_TABLENAME, $id);

	wp_die();
}

add_action("wp_ajax_adve_del", "ajax_adve_del");

if (!is_plugin_active("adverttorial/index.php")) 
{
	update_option("Adverttorial_Template", "g1");
	update_option("Adverttorial_Template_Label", "G1");
}

/** ********
 * init
 **/
function Adverttorial_Init()
{

	global $Ezeksoft_Adverttorial, $wpdb;

	// cria banco de dados se no existe
	$Ezeksoft_Adverttorial->create_table(ADVERTTORIAL_TABLENAME, array(
		"uri" => "VARCHAR(1000)",
		"html" => "MEDIUMBLOB",
		"headline" => "VARCHAR(500)",
		"author" => "VARCHAR(500)",
		"date" => "VARCHAR(50)",
		"template" => "VARCHAR(255)",
		"template_main_color" => "VARCHAR(255)",
		"template_sub_color" => "VARCHAR(255)",
		"template_main_text_color" => "VARCHAR(255)",
		"sub_headline" => "TEXT",
		"tuse" => "TEXT",
		"ppriv" => "TEXT",
		"headertit" => "VARCHAR(1000)",
		"sub_headertit" => "VARCHAR(1000)",
		"scripts" => "MEDIUMBLOB",
	));

	$wpdb->query("ALTER TABLE ".ADVERTTORIAL_TABLENAME." ADD headertit VARCHAR(1000) NULL AFTER ppriv"); 
	$wpdb->query("ALTER TABLE ".ADVERTTORIAL_TABLENAME." ADD sub_headertit MEDIUMBLOB NULL AFTER headertit"); 
	$wpdb->query("ALTER TABLE ".ADVERTTORIAL_TABLENAME." ADD scripts MEDIUMBLOB NULL AFTER sub_headertit"); 



	// pega dados da URI caso ela exista no plugin
	$Advertorial_URI = $Ezeksoft_Adverttorial->get_option(ADVERTTORIAL_TABLENAME, $Ezeksoft_Adverttorial->get_site_uri());

	// se retornou dados, a URI est registrada como sendo do plugin
	if ($Advertorial_URI)
	{

		$Adve_view_data = $Ezeksoft_Adverttorial->get_option(ADVERTTORIAL_TABLENAME, $Ezeksoft_Adverttorial->get_site_uri());

		$page_data = $Adve_view_data[0];

		// $Adve_Template = get_option("Adverttorial_Template");
		// $Adve_Template = $Adve_Template ? $Adve_Template : "g1";


		$Adverttorial_Headline = $page_data->headline;
		$Adverttorial_HTML = $page_data->html;
		$Adverttorial_Author = $page_data->author;
		$Adverttorial_Date = $page_data->date;
		$Adve_Template = $page_data->template;
		$Adve_Template_Main_Color = $page_data->template_main_color;
		$Adve_Template_Sub_Color = $page_data->template_sub_color;

		$Adverttorial_Sub_Headline = $page_data->sub_headline;
		$Adverttorial_Sub_TUse = $page_data->tuse;
		$Adverttorial_Sub_PPriv = $page_data->ppriv;

		$Adverttorial_HeaderTit = $page_data->headertit;
		$Adverttorial_Sub_HeaderTit = $page_data->sub_headertit;
		$Adverttorial_Scripts = $page_data->scripts;


		$Adve_File = dirname( __FILE__ ) . DIRECTORY_SEPARATOR. "themes" .DIRECTORY_SEPARATOR. $Adve_Template . DIRECTORY_SEPARATOR. "index.php";

		$Adve_File_Default = dirname( __FILE__ ) . DIRECTORY_SEPARATOR. "themes" .DIRECTORY_SEPARATOR. "g1" . DIRECTORY_SEPARATOR. "index.php";

		if (file_exists($Adve_File))
		{
			require($Adve_File);
		}
		else 
		{
			if (file_exists($Adve_File_Default))
				require($Adve_File_Default);
			else
				echo "Nenhum template aplicado.";
		}
		

		die();
		
	}

}

add_action("init", "Adverttorial_Init");