<?php require(dirname( __FILE__ ) . DIRECTORY_SEPARATOR."layout_form.php"); ?>

<script type="text/javascript">
	Adve_Save.onclick = function() {
		var editor = document.querySelector("#advEditor > div:first-child iframe");
		var getHTML = editor.contentWindow.document.body.innerHTML;

		if (!Adve_URI.value.length) {
			alert("Preencha o campo permalink.");
			Adve_URI.focus();
			return false;
		}

		var data = {
			action: "adve_save",
			uri: Adve_URI.value,
			date: date_string,
			author: Adve_Author.value,
			headline: Adve_Headline.value, 
			html: encodeURIComponent(getHTML),
			template: Adve_Template.innerText.trim(),
			template_main_color: Adve_Template_MainColor.innerText.trim(),
			template_sub_color: Adve_Template_SubColor.innerText.trim(),

			sub_headline: Adve_SubHeadLine.value, 
			tuse: Adve_Termos_Uso.value, 
			ppriv: Adve_Politicas_Privacidade.value,
			
			headertit: Adve_HeaderTit.value,
			sub_headertit: Adve_Sub_HeaderTit.value,
			scripts: Adve_Scripts.value
		}


		var tmp_str_1 = this.innerText;
		this.innerText = "Aguarde...";
		jQuery.post(ajaxurl, data, function(response) {
			Adverttorial_Edit.innerText = tmp_str_1;
			document.location.reload();
		});
	}

	<?php echo $Ezeksoft_Adverttorial->checklc(); ?>

	$checker({ key: "<?php echo get_option('adverttorial'); ?>", domain: document.location.host },
	function(response) {}, function(response) {
		alert("Erro! Licença expirada ou cancelada. Suporte: ezektrader@gmail.com");
		document.location.reload();
	});		

</script>

<?php if (!$Adve_exists_Comments): ?>
<h3>Adicionar comentários, templates e outras ferramentas</h3>
<div>
	<ul style="list-style: inherit; margin-left: 20px">
		<li>Se você quer criar advertoriais que convertem mais com prova social, <a target="_blank" href="http://ezeksoft.com/adverttorial-plugins?utm_source=Adverttorial-in-plugin">baixe o plugin de comentários</a> próprio para o <b>Adverttorial</b>.</li>

		<li>Para saber quais são todos os plugins do <b>Adverttorial</b>, <a target="_blank" href="http://ezeksoft.com/adverttorial-plugins?utm_source=Adverttorial-in-plugin">clique aqui</a>.</li>
	</ul>
</div>
<?php endif; ?>


<div style="margin-top: 30px">
	<h3>Advertoriais criados</h3>

		<div>
		<label style="margin-top:10px;display:block">Escolha o Advertorial pra aplicar a exportação:</label>
		<select id="Adve_ID_ImportsExports" style="display: block; width: 300px; margin-top: 10px;">
		<?php if($data): foreach($data as $item): ?>
			<option <?php echo isset($data->adve_id) && $data->adve_id == $item->id ? 'selected' : '';  ?> value="<?php echo $item->id; ?>"><?php echo $item->uri; ?></option>
		<?php endforeach; endif; ?>
		</select>
		
	</div>

	<div style="margin-bottom: 40px; margin-top: 10px">
		<div>
			<button class="cmt-btn" onclick="AdveHTML_Imports_ViewPort()">Importar</button>
			<button class="cmt-btn" onclick="AdveHTML_Exports(this)">Exportar</button>
			<button class="cmt-btn" onclick="AdveHTML_Exports_All(this)">Exportar Todos</button>
		</div>

		<div id="cmt_imports_dt_viewPort" style="display: none">

			<label style="margin-bottom: 10px;margin-top: 10px; display:block">Cole o conteúdo do arquivo baixado aqui.</label>
			<div style="display: flex">
				<textarea id="Adve_Imports_String" style="width: 300px; height: 30px"></textarea>
				<button onclick="AdveHTML_Imports(this)" class="cmt-btn">Realizar importação do advertorial</button>
				<button onclick="AdveHTML_Clear(this)" class="cmt-btn" style="margin-left: 5px">Limpar</button>
			</div>
		</div>
	</div>

	<script type="text/javascript">
		function AdveHTML_Clear(this_) {
			 Adve_Imports_String.value = "";
		}

		function AdveHTML_Imports(this_) {
			var str = Adve_Imports_String.value.trim();

			try {
				var str = JSON.parse(str);
			}
			catch {
				alert('Não é um arquivo válido!');
				return false;
			}

			var data = {
				action: "adve_import_adve",
				string: str//,
				// id: Adve_ID_ImportsExports.value
			}
			console.error(data);

			var tmp = this_.innerText;
			this_.innerText = 'Aguarde...';
			jQuery.post(ajaxurl, data, function(response) {
				this_.innerText = tmp;	
				document.location.reload();	
			});

			
		}

		function AdveHTML_Imports_ViewPort() {
			cmt_imports_dt_viewPort.style.display = 'block';
		}

		function AdveHTML_Exports(this_) {
			var tmp = this_.innerText;
			this_.innerText = 'Aguarde...';
			document.location = ajaxurl + "?action=adve_export_adve&id=" + Adve_ID_ImportsExports.value;
			setTimeout(function() {
				this_.innerText = tmp;
			}, 1000);
		}

		function AdveHTML_Exports_All(this_) {
			var tmp = this_.innerText;
			this_.innerText = 'Aguarde...';
			document.location = ajaxurl + "?action=adve_export_adve_all";
			setTimeout(function() {
				this_.innerText = tmp;
			}, 1000);
		}
	</script>


	<div id="adve_list">
		<?php if (sizeof($data)): ?>
			<?php foreach ($data as $item):  ?>
				<div style="font-weight:bold;display:flex;margin-bottom:10px;padding-bottom:5px;border-bottom:1px solid #dedede;width:500px" id="List_Item_<?php echo $item->id; ?>">
					<div style="width: 400px;overflow: hidden"><a href="<?php echo get_site_url().'/'.$item->uri; ?>" target="_blank"><?php echo get_site_url().'/'.$item->uri; ?></a></div>&nbsp;
					<div><button class="qzz-btn" onclick="Adverttorial_Edit(<?php echo $item->id; ?>)">Editar</button></div>
					<div><button style="margin-left: 5px" class="qzz-btn" onclick="Adverttorial_Del(<?php echo $item->id; ?>, this)">Apagar</button></div>
				</div>
			<?php endforeach; ?>
		<?php else: ?>
			<div>Nenhum link criado.</div>
		<?php endif; ?>
	</div>
</div>

<script type="text/javascript">

	function Adverttorial_Edit(id) {
		var data = {
			action: "adve_edit_order",
			id: id
		}

		jQuery.post(ajaxurl, data, function(response) {			
			document.location = '<?php echo get_admin_url() . "admin.php?page=adverttorial-editar"; ?>';
		});
	}

	function Adverttorial_Del(id, el) {
		var data = {
			action: "adve_del",
			id: id
		}

		var children = adve_list.children.length;
		var hiddens = 0;

		el.parentNode.parentNode.style.display = 'none';
		el.parentNode.parentNode.setAttribute("visibility", "hidden");

		var visibilities = document.querySelectorAll("[visibility]");
		if (visibilities.length) visibilities.forEach(function(v) {
			hiddens ++;
		});

		if (children == hiddens)		
			adve_list.innerHTML = "Nenhum link criado.";

		jQuery.post(ajaxurl, data, function(response) {			
			//document.location.reload();
		});
	}

</script>